<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title></title>
<link rel="shortcut icon" href="{{ url_for('static', filename='css/images/5028-512.png') }}" />

<script src="{{ url_for('static', filename='js/vendor/jquery-3.2.1/jquery-3.2.1.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jquery-ui-1.12.1/jquery-ui.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jquery.scrollTo-2.1.2/jquery.scrollTo.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jstorage/jstorage.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/md5/md5.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/json2/json2.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jsonpath/jsonpath-0.8.0.js') }}"></script>

<script src="{{ url_for('static', filename='js/class.base-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.bootstrap-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.datamodels-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.gui-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.inline_templates-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.json-path-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.loader-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.output-hashes-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.query-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.query-history-3.16.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.query-window-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.request-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.results-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.scratchpad-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.services-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.services-gui-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.stored-queries-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.tabular-results-3.16.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.timer-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.tokens-3.15.js') }}"></script>

<script src="{{ url_for('static', filename='js/ns.bind-keys-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.config-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.functions-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.main-3.17.js') }}"></script>

<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/inline_templates.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/jquery-ui.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/style-3.17.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/json-path-3.13.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/help-3.17.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/result-view-3.15.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/query-history-3.15.css') }}" />

<script>
$(document).ready(function(e)
{

	/*
		globals
		jQuery (incl. $.jStorage)
		jsonPath

		var config (config.js)
		var functions (functions.js)
		var bindKeys (bind-keys.js)
		var main (main.js) for convenience
	*/

	main.onLoad();

	scratchpad = new Scratchpad(config,{
		name: "Query scratchpad for the Netherlands Biodoversity API",
		version: "2.x", // actual version is retrieved from version history table
		date: "2017", 	// actual date retrieved from version history table
		author: "Maarten Schermer",
		// email: "maarten.schermer@naturalis.nl",
	});

	$('.url-origin').html(scratchpad.url.origin);

	templates = new Templates();
	timer = new Timer(config,scratchpad.getServer());

	scratchpad.setTemplates([{ label: "messageCloseTpl", code: templates.fetchTemplate("messageCloseTpl") }]);

	if (!scratchpad.checkMinimalRequirements())
	{
		scratchpad.setMessage("cannot load",false);
		var e=scratchpad.getFatalErrors();
		e=e.map(function(a) { return "• " + a;});
		e.unshift("Fatal error(s):");
		alert(e.join("\n"));
		return;
	}

	timer.setTemplates([
		{ label: "timerCheckpointTpl", code: templates.fetchTemplate("timerCheckpointTpl") },
		{ label: "timerListTpl", code: templates.fetchTemplate("timerListTpl") },
	]);

	scratchpad.setMessage("loading");

	loader = new Loader(config);
	loader.setTimer(timer,scratchpad.getServer());
	loader.disablePage();

	// required for loader div to actually render
	setTimeout(function()
	{
		scratchpad.printApplicationInfo();
		scratchpad.setServer({
			url: window.location.protocol + "//{{ nba_address }}",
			proxyUrl: window.location.protocol + "//" + window.location.host,
			proxyPath: "{{ url_for('proxy_request') }}",
			urlTestPath: "{{ url_for('url_test_request') }}",
			nbaServer: window.location.protocol + "//{{ nba_address }}",
			nbaVersion: "{{ nba_version }}",
			private_nba_address: "{{ private_nba_address }}",
			public_nba_address: "{{ nba_address }}"
		});

		query_window = new QueryWindow(config,scratchpad.getServer());
		tabular_results = new TabularResults(config);
		services = new Services(config,scratchpad.getServer());
		data_models = new DataModels(config,scratchpad.getServer());
		services_gui = new ServicesGUI(config);
		gui = new GUI(config,scratchpad.getServer());
		bootstrap = new Bootstrap(config,scratchpad.getServer());
		query = new Query();
		request = new Request(config,scratchpad.getServer());
		results = new Results(config);
		json_path = new JsonPath();
		tokens = new Tokens();
		output_hashes = new OutputHashes();
		query_history = new QueryHistory();

		request.setTimer(timer);

		json_path.setTemplates([
			{ label: "helpText_JSONpath", code: templates.fetchTemplate("helpText_JSONpath") },
		]);

		gui.setTemplates([
			{ label: "clickableJsonError_tpl", code: templates.fetchTemplate("clickableJsonError_tpl") },
		]);

		tokens.setTemplates([
			{ label: "retrievedBatchCountTpl", code: templates.fetchTemplate("retrievedBatchCountTpl") },
		]);

		results.setTemplates([
			{ label: "responseErrorTpl", code: templates.fetchTemplate("responseErrorTpl") },
			{ label: "responseSuccessTpl", code: templates.fetchTemplate("responseSuccessTpl") },
			{ label: "otherFormatsMessageTpl", code: templates.fetchTemplate("otherFormatsMessageTpl") },
			{ label: "nbaErrorMsgTpl", code: templates.fetchTemplate("nbaErrorMsgTpl") },
			{ label: "jiraNoFormatTpl", code: templates.fetchTemplate("jiraNoFormatTpl") },
			{ label: "saveResultDialogTpl", code: templates.fetchTemplate("saveResultDialogTpl") },
			{ label: "preTpl", code: templates.fetchTemplate("preTpl") },
			{ label: "totCountTpl", code: templates.fetchTemplate("totCountTpl") },
			{ label: "maxDisplayedMessageTpl", code: templates.fetchTemplate("maxDisplayedMessageTpl") },
		]);

		output_hashes.setTemplates([
			{ label: "hashTpl", code: templates.fetchTemplate("hashTpl") },
			{ label: "hashesTpl", code: templates.fetchTemplate("hashesTpl") },
		]);

		query_history.setTemplates([
			{ label: "queryListTpl", code: templates.fetchTemplate("queryListTpl") },
			{ label: "queryListItemTpl", code: templates.fetchTemplate("queryListItemTpl") },
			{ label: "querySessionDialogBodyTpl", code: templates.fetchTemplate("querySessionDialogBodyTpl") },
		]);

		query_window.setTemplates([
			{ label: "queryHintField_tpl", code: templates.fetchTemplate("queryHintField_tpl") },
			{ label: "queryOptional_tpl", code: templates.fetchTemplate("queryOptional_tpl") },
			{ label: "queryHintGroupField_tpl", code: templates.fetchTemplate("queryHintGroupField_tpl") },
			{ label: "queryHintQuery_tpl", code: templates.fetchTemplate("queryHintQuery_tpl") },
			{ label: "queryHintSimpleQuery_tpl", code: templates.fetchTemplate("queryHintSimpleQuery_tpl") },
			{ label: "buttonContextTpl", code: templates.fetchTemplate("buttonContextTpl") },
			{ label: "callFunctionContextTpl", code: templates.fetchTemplate("callFunctionContextTpl") },
			{ label: "codeBitContextHeaderTpl", code: templates.fetchTemplate("codeBitContextHeaderTpl") },
			{ label: "codeBitContextTpl", code: templates.fetchTemplate("codeBitContextTpl") },
			{ label: "cursorPositionTpl", code: templates.fetchTemplate("cursorPositionTpl") },
			{ label: "editContextTpl", code: templates.fetchTemplate("editContextTpl") },
			{ label: "queryContextItemsTpl", code: templates.fetchTemplate("queryContextItemsTpl") },
			{ label: "queryContextMainItemTpl", code: templates.fetchTemplate("queryContextMainItemTpl") },
			{ label: "queryOperatorContextTpl", code: templates.fetchTemplate("queryOperatorContextTpl") },
			{ label: "codeBit_condition", code: templates.fetchTemplate("codeBit_condition") },
			{ label: "codeBit_query", code: templates.fetchTemplate("codeBit_query") },
			{ label: "codeBit_query_big", code: templates.fetchTemplate("codeBit_query_big") },
			{ label: "codeBit_query_name_resolution", code: templates.fetchTemplate("codeBit_query_name_resolution") },
			{ label: "codeBit_query_null_condition", code: templates.fetchTemplate("codeBit_query_null_condition") },
			{ label: "codeBit_nameResolutionRequest", code: templates.fetchTemplate("codeBit_nameResolutionRequest") },
			{ label: "emptyFieldQueryTpl", code: templates.fetchTemplate("emptyFieldQueryTpl") },
			{ label: "emptyGroupFieldQueryTpl", code: templates.fetchTemplate("emptyGroupFieldQueryTpl") },
			{ label: "emptyQueryTpl", code: templates.fetchTemplate("emptyQueryTpl") },
			{ label: "jiraNoFormatTpl", code: templates.fetchTemplate("jiraNoFormatTpl") },
			{ label: "completeRequestExportTpl", code: templates.fetchTemplate("completeRequestExportTpl") },
			{ label: "context_useTabularHeadersAsFieldsTpl", code: templates.fetchTemplate("context_useTabularHeadersAsFieldsTpl") },
		]);

		tabular_results.setTemplates([
			{ label: "tabularViewHeaderCell_tpl", code: templates.fetchTemplate("tabularViewHeaderCell_tpl") },
			{ label: "tabularColumnMessage_tpl", code: templates.fetchTemplate("tabularColumnMessage_tpl") },
			{ label: "tabularViewRow_tpl", code: templates.fetchTemplate("tabularViewRow_tpl") },
			{ label: "tabularViewCell_tpl", code: templates.fetchTemplate("tabularViewCell_tpl") },
			{ label: "tabularViewTable_tpl", code: templates.fetchTemplate("tabularViewTable_tpl") },
			{ label: "responseTabularTpl", code: templates.fetchTemplate("responseTabularTpl") },
			{ label: "responseSuccessTpl", code: templates.fetchTemplate("responseSuccessTpl") },
			{ label: "tabularViewVerticalHeaderCell_tpl", code: templates.fetchTemplate("tabularViewVerticalHeaderCell_tpl") },
			{ label: "maxDisplayedMessageTpl", code: templates.fetchTemplate("maxDisplayedMessageTpl") },
			{ label: "tabularNoticeCell_tpl", code: templates.fetchTemplate("tabularNoticeCell_tpl") },
		]);

		services_gui.setTemplates([
			{ label: "serviceDisabledTpl", code: templates.fetchTemplate("serviceDisabledTpl") },
			{ label: "serviceTpl", code: templates.fetchTemplate("serviceTpl") },
			{ label: "serviceExtrasTpl", code: templates.fetchTemplate("serviceExtrasTpl") },
			{ label: "serviceDefaultTpl", code: templates.fetchTemplate("serviceDefaultTpl") },
			{ label: "serviceSeparatorTpl", code: templates.fetchTemplate("serviceSeparatorTpl") },
			{ label: "documentFieldSuggestionTpl", code: templates.fetchTemplate("documentFieldSuggestionTpl") },
			{ label: "documentFieldSuggestionsTpl", code: templates.fetchTemplate("documentFieldSuggestionsTpl") },
		]);

		results.setTimer(timer,scratchpad.getServer());

		services.setDefaultRestServiceLists(config.defaultServiceList);
		services.setServices();
		services.addStaticServices();

		services.testServices();
		// console.log("!!! commented out services.testServices(); !!!");

		services.setService();

		request.setService(services.getService());
		query.setService(services.getService());

		query_window.setTabularResults(tabular_results);
		query_window.setService(services.getService());
		query_window.setQueryHint();

		data_models.setDocumentTypes(services.getDocumentTypes());
		data_models.setDataModels();

		services_gui.setServices(services.getServices());
		services_gui.printServices();
		services_gui.setService(services.getService());
		services_gui.setPlaceholderString( data_models.getAvailableFields().length==0 ? "found no fieldnames" : "type field name" );
		services_gui.setAvailableFields(data_models.getAvailableFields())
		services_gui.setIncludeNonSearchableDocumentFields(config.includeNonSearchableDocumentFields)
		services_gui.setQueryWindow(query_window);
		services_gui.printTypeToFindPlaceholder();
		services_gui.bindDocumentFieldsSearchKeyUp();

		gui.setService(services.getService());
		gui.setResultWindowUrl();
		gui.setServerStatusLink();

		query_window.bootstrapWindow();
 		query_window.bootstrapContextmenu();

 		tabular_results.bootstrapWindow();

 		bootstrap.bootstrapSupportWindows();
		bootstrap.resizeQueryListPanels();
		bootstrap.bootstrapLeftPanelsResizeTimer();
		bootstrap.startLeftPanelsResizeTimer()

		gui.checkDocumentFieldsIncludeExtras();
		gui.checkDocumentFieldsShowAll();
		gui.checkAddExplain();
		gui.toggleAddExplain();
		gui.enableCtrlSToggle();
		gui.enableMonthlyBackupToggle();
		gui.setResultQueryListener();

		bindKeys.doBind();

		if (!$.jStorage.storageAvailable())
		{
			alert("No local storage available.\nYou can write and execute queries, but cannot save them.");
		}
		else
		{
			stored_queries = new StoredQueries(config,scratchpad.getServer());

			stored_queries.setTemplates([
				{ label: "queryTpl", code: templates.fetchTemplate("queryTpl") },
				{ label: "groupTpl", code: templates.fetchTemplate("groupTpl") },
				{ label: "useQuerySymbolAndServiceTpl", code: templates.fetchTemplate("useQuerySymbolAndServiceTpl") },
				{ label: "useQuerySymbolTpl", code: templates.fetchTemplate("useQuerySymbolTpl") },
				{ label: "noteSymbolTpl", code: templates.fetchTemplate("noteSymbolTpl") },
				{ label: "emptyNoteSymbolTpl", code: templates.fetchTemplate("emptyNoteSymbolTpl") },
				{ label: "importErrorTpl", code: templates.fetchTemplate("importErrorTpl") },
				{ label: "importOptionsTpl", code: templates.fetchTemplate("importOptionsTpl") },
			]);

			stored_queries.setTemplateGroup({ label: "example_queries", group: templates.fetchTemplateGroupTemplates("example_queries")});

			stored_queries.cleanUp();
			stored_queries.setQueries();
			stored_queries.setMonthlyBackupToggle();
			stored_queries.runAutoQuerybackup();
			stored_queries.createExampleQueries();

			stored_queries.setServices(services.getServices());
			stored_queries.setService(services.getService());
			stored_queries.setQueries();
			stored_queries.printList();

			gui.toggleQuickExportButton(stored_queries.getQueries().length>0);
			gui.fileInputEventBind();
		}

		query_window.loadExternalQuery('{{ query|tojson|safe }}',{{ strip_url }});
		services_gui.selectServiceByKey('{{ service_key }}');
		query_window.executeExternalQuery({{ execute_query }});
		loader.enablePage();

		bootstrap.startKeyListener();
		bindKeys.depressAllKeys();

	 }, 1);

});
</script>
</head>

<body>

<div id="page">

	<div id="top">

		<div id="panel-services">

			<select
				id="services"
				title="service list"
				onchange="main.servicesOnChange()"
				onkeyup="services_gui.jumpToServiceIndex(event);">
			</select>

			<a
				id="serverStatus"
				title="server link"
				href=""
				target="_new">NBA server root
			</a>

			<span
				id="serverResponseCode"
				title="last server http response code"
				class="hint"
				style="margin-left:10px">
			</span>

		</div>

		<span id="message"></span>

	</div>
	<!-- /top -->

	<div id="body">

		<div id="left">

			<div id="panel-query">
				<textarea title="query window" id="query" placeholder="query"></textarea>
			</div>
			<!-- /panel-query -->

			<div id="panel-query-options">

	            <input title="execute query" type="button" id="query-trigger" value="execute query" onclick="main.executeQuery()"/>

	            <span title="execute query alternative" class="hint">(or Ctrl+Enter)</span>

	            <span class="divider">|</span>

	            <span title="query window manipulation">

	                <input
	                	type="text"
	                    title="type to find field name"
	                    id="documentFieldsSearch"
	                    placeholder="type field name"
	                    class="documentFieldsSearch" />

	                <input
	                	type="checkbox"
	                    id="documentFieldsIncludeExtras"
	                    onchange="gui.checkDocumentFieldsIncludeExtras();$('#documentFieldsSearch').trigger('keyup');"
	                    class="invisible-checkbox"/>

	                <label title="include datatypes and analyzers in search" for="documentFieldsIncludeExtras">
	                    <span class="document-fields-include-extras check-box-label check-box-label-on">&#9744;</span>
	                    <span class="document-fields-include-extras check-box-label check-box-label-off">&#9745;</span>
	                </label>

	                <input
	                	type="checkbox"
	                    id="documentFieldsShowAll"
	                    onchange="gui.checkDocumentFieldsShowAll();$('#documentFieldsSearch').trigger('keyup');"
	                    class="invisible-checkbox"/>

	                <label title="show fields for all document types" for="documentFieldsShowAll">
	                    <span class="document-fields-show-all check-box-label check-box-label-on">&#9744;</span>
	                    <span class="document-fields-show-all check-box-label check-box-label-off">&#9745;</span>
	                </label>

	            </span>
	            <!-- query /window manipulation -->

				<span class="divider">|</span>

	            <span
	            	title="format query (Ctrl+click for compact format)" class="link"
	                onclick="query_window.formatQuery();" />format query</span>

				<span class="divider">|</span>

				<span
					title="decode query (Ctrl+click to encode)"
					alt-title="decode query"
					class="link"
					onclick="query_window.decodeQuery();" />decode query</span>

				<span class="divider">|</span>

	            <span
	            	title="copy query (Ctrl+click for JIRA-format)"
	                alt-title="copy query"
	                class="link"
	                onclick="query_window.copyQueryToClipboard();"/>copy query</span>

	            <span
	            	title="copy query +"
	                class="link"
	                onclick="
	                    query_window.setFullRequestUrl(gui.getResultWindowUrl());
	                    query_window.copyCompleteRequestToClipboard();
	                    query_window.setMessage('copied all request elements to clipboard');"/>&nbsp;+&nbsp;</span>

	            <span class="divider">|</span>

	            <span
	            	title="clear query (or Ctrl+F7)"
	                alt-title="clear query"
	                class="link"
	                onclick="
	                    query_window.clear();
	                    query_window.onChange();
	                    query_window.focusWindow();"/>clear</span>

	            <span class="divider">|</span>

	            <span class="explain-group">

	                <input
	                	type="checkbox"
	                	id="addExplain"
	                	onchange="gui.checkAddExplain();"
	                	class="invisible-checkbox" />

	                <label title="add explain to query (for selected endpoints)" alt-title="add explain" for="addExplain">
	                    <span class="add-explain check-box-label check-box-label-on">&#9744;</span>
	                    <span class="add-explain check-box-label check-box-label-off">&#9745;</span>
	                    ⁉
	                </label>

	                <span
	                	class="link show-explain-log"
	                    onclick="results.showExplainLog();">show log</span>

	                <span class="divider">|</span>

	            </span>
	            <!-- /explain-group -->

	            <span title="cursor position" class="hint" id="cursor-position">[0,0]</span>

	            <span class="token-query-group">

	                <span class="divider">|</span>

	                <input
	                	title="get next batch"
	                    type="button"
	                    id="token-query-trigger"
	                    value="next batch"
	                    onclick="main.executeTokenQuery()" />

	                <span class="hint batch-count-and-total" title="retrieved records / total (retrieved batches)">-1</span>

	            </span>
	            <!-- /token-query-group -->

			</div>
			<!-- /panel-query-options -->

			<div id="panel-url">
				<textarea id="resultQuery" title="resulting URL" alt-title="resulting url"></textarea>
			</div>
			<!-- /panel-url -->

			<div id="panel-result-options">

				<input
					title="run altered query"
					type="button"
					value="run altered query"
					id="run-altered-query"
					data-disabled="1"
					onclick="main.executeAlteredQuery()"/>

				<span title="query run options" class="results">
					<a
						title="open query directly in new window"
						alt-title="open directly"
						class="resultUrl" href=""
						target="_blank">open</a><div class="icon-container icon-external-link"></div>

					<span class="divider">|</span>

					<span class="link" onclick="gui.toggleResultFullScreen(true);" title="full screen (Esc to exit)" alt-title="full screen">
						<div class="icon-container icon-full-screen"></div>
					</span>

					<span class="divider">|</span>

					<span
						title="copy URL (Ctrl+click for JIRA format)"
						alt-title="copy URL"
						class="link"
						onclick="
							results.copyResultURLToClipboard();
							scratchpad.setMessage('link copied to clipboard');">copy URL</span>

					<span class="link" onclick="
							results.copyScratchpadURLToClipboard(query_window.getText(),services.getService().key);
							scratchpad.setMessage('Scratchpad link copied to clipboard');"
							title="copy link to Scratchpad including query"
							alt-title="copy Scratchpad URL + query">
						<div class="icon-container icon-share"></div>
					</span>

					<span class="localresults">

						<span class="divider">|</span>

						<span
							title="clear results"
							class="link"
							onclick="results.clear();" />clear</span>,

						<span class="tabular-view">
							<span
								title="copy results (JSON) (Ctrl+click for JIRA format)"
								class="link"
								alt-title="copy results"
								onclick="results.copyResultsToClipboard()"
							/>copy</span> or
							<span
								title="download results as JSON (press Ctrl and click to specify filename)"
								alt-title="download results"
								class="link"
								onclick="
									results.setCurrentResultView(tabular_results.getCurrentResultView());
									results.downloadResults();"/>download results</span>
						</span>
						<!-- /tabular-view -->

						<span class="json-view">
							<span
								title="copy results (tabular data)"
								alt-title="copy results"
								class="link"
								onclick="results.copyResultsToClipboard('tsv')"
							/>copy</span> or
							<span
								title="download results as tab separated file (press Ctrl and click to specify filename)"
								alt-title="download results"
								class="link"
								onclick="
									results.setCurrentResultView(tabular_results.getCurrentResultView());
									results.downloadResults();"/>download results</span>
						</span>
						<!-- /json-view -->

						<span class="divider">|</span>

						<span onclick="tabular_results.changeResultView();" alt-title="switch result view">
							<span alt-title="switch view" title="switch to JSON view" class="link result-view-switch json-view">{*}</span>
							<span alt-title="switch view" title="switch to tabular view" class="link result-view-switch tabular-view">[*]</span>
						</span>

						<span title="rotate table" class="link json-view rotate-table" onclick="tabular_results.rotate()">
							<div class="icon-container icon-rotate-table"></div>
						</span>

						<span class="divider">|</span>

						<input
							type="text"
							id="resultSearch"
							placeholder="search in results"
							title="type to search in results"
							onkeyup="results.findAndScroll();"/>

						<span
							class="link"
							title="previous result"
							onclick="results.findAndScroll('up');">&uarr;</span>

						<span
							class="link"
							title="next result"
							onclick="results.findAndScroll('down');">&darr;</span>

						<span class="hint">
							<span id="resultSearchCount" title="total number found">0</span>
							[<span id="resultSearchLine" title="current line">0</span>]
						</span>

						<span class="divider">|</span>

						<span
							class="link"
							id="JSONpathToggle"
							onclick="$('#JSONpathDialog').toggle();json_path.init();"
							title="search results via JSONPath">JSONPath</span>

						<span class="divider">|</span>

						size:

						<span
							class="result-total-size"
							title="result total size (double click to copy)"
							ondblclick="functions.copyToClipboard($(this).html());scratchpad.setMessage('copied');"></span>
					</span>
					<!-- /localresults -->
				</span>
				<!-- /query run options -->

			</div>
			<!-- /panel-result-options -->

			<div id="panel-result">

				<!-- TODO is this still in use? -->
				<object title="remote result window" id="remoteresults" data=""></object>

				<div id="localresults" title="result window" alt-title="result window" class="localresults"></div>

			</div>
			<!-- /panel-result -->

		</div>
		<!-- /left -->

		<div id="right">

			<div id="save-query">

				<input title="query name to save"
					type="text"
					id="queryName"
					value=""
					placeholder="name of query to save (max. 64 chars)"
					maxlength="64" />

				<input title="save query" type="button" value="save" onclick="
					stored_queries.hideExportOptionsWindow();
					stored_queries.saveQuery();
					stored_queries.setQueries();
					stored_queries.printList();
					stored_queries.highlightNewQuery();" />
				<span title="clear query name"
					onclick="$('#queryName').val('');" class="symbol link" title="clear query name">x</span>

			</div>

			<div id="query-list" class="query-list">
				<span id="query-list-header">saved queries (<span class="setting link" onclick="query_history.showHistory();">session history</span>):</span>
				<ul title="saved queries" id="queries" class="queries"></ul>
			</div>

			<p>
				<div class="timer" id="timer"></div>
			</p>

			<p>
				<div class="hashes" id="hashes"></div>
			</p>

			<p>
				<div class="quick-export query-list">
					<span
						class="setting link"
						title="click to export all saved queries to download folder"
						onclick="stored_queries.quickExport();">quick export all queries
					</span>
				</div>

				<span
					class="export link setting" title="more options"
					onclick="
						$('.export').toggle();
						bootstrap.resizeQueryListPanels();
						stored_queries.selectedQueryCount();">
					more options
				</span>

				<div class="export options" id="exportOptions">

					<span title="close" class="setting link" onclick="
						$('.export').toggle();
						bootstrap.resizeQueryListPanels();">
						close options
					</span>

					<div class="links">

						<div title="query backup file import" class="setting">
							<div style="margin-bottom:5px">select query backup file to import:</div>
							<input type="file" id="file-input"/>
						</div>

						<hr />

						<input type="checkbox" id="enableMonthlyBackup" class="invisible-checkbox"
							onchange="
								gui.enableMonthlyBackupToggle();
								stored_queries.setMonthlyBackupSetting();
							" />
						<label title="enable automatic monthly query-backup to downloads folder" for="enableMonthlyBackup">
							<span class="enable-backup check-box-label check-box-label-on">&#9744;</span>
							<span class="enable-backup check-box-label check-box-label-off">&#9745;</span>
							<span class="setting link" title="enable automatic monthly query-backup">enable automatic monthly query-backup</span>
						</label>

						<hr />

						<span class="setting link" title="export selected queries"
							onclick="stored_queries.export();">export selected queries to query window</span><br />
						<span class="setting link" title="import queries"
							onclick="stored_queries.importFromQueryWindow();">import queries from query window</span><br />
						<span class="setting link" title="delete selected queries"
							onclick="stored_queries.queryDeleteSelected();">delete selected queries</span><br />
						<span class="setting link additional" title="select all"
							onclick="stored_queries.exportQueryToggleAll(true);">select all</span> /
						<span class="setting link additional" title="select none"
							onclick="stored_queries.exportQueryToggleAll(false);">none</span>
						<span class="setting additional">(<span class="export-query-count">0</span>)</span><br />
						<br />
						<span class="setting link" title="(re)import example queries (if they are not already present)"
							onclick="stored_queries.createExampleQueries(true);">(re)import example queries</span><br />

						<a class="setting link" href="{{ scratchpad_path }}/maintenance">rename and reorder queries</a><br />

						<hr />

						<input type="checkbox" id="enableCtrlS" class="invisible-checkbox"
							onchange="gui.enableCtrlSToggle();"/>
						<label title="enable Ctrl+s" for="enableCtrlS">
							<span class="enable-ctrl-s check-box-label check-box-label-on">&#9744;</span>
							<span class="enable-ctrl-s check-box-label check-box-label-off">&#9745;</span>
							<span class="setting link">ctrl+s saves query</span>
						</label>

						<br />

						<span class="setting link" id="timerToggle" title="query timer" onclick="
							timer.toggle();
							bootstrap.resizeQueryListPanels();">toggle timer</span>
						<br />
						<span class="setting link" id="hashesToggle"  title="output hashes" onclick="
							output_hashes.toggle();
							bootstrap.resizeQueryListPanels();">toggle output hashes</span>
						<br />
						<span class="setting link" title="toggle query window context menu"
							onclick="query_window.queryWindowContextToggle();">
							toggle query window context menu
						</span>

						<br />

						<hr />

						<span class="setting" title="http request method">
							http request method:
							<label class="link"><input type="radio" name="force-method" value="auto" checked>auto</label>
							<label class="link"><input type="radio" name="force-method" value="GET">GET</label>
							<label class="link"><input type="radio" name="force-method" value="POST">POST</label>
						</span>

						<hr />

						<span class="setting">
							explain level:
							<select id="explainLevel">
								<option value="trace">trace</option>
								<option value="debug" selected="selected">debug</option>
								<option value="info">info</option>
								<option value="warn">warn</option>
								<option value="error">error</option>
								<option value="fatal">fatal</option>
							</select>
						</span>

						<br />

					</div>

				</div>

			</p>

			<div id="notesDiv">
				<span id="notesDragHandle">
					<span title="note title" id="notesName"></span> <span id="notesSize" class="symbol"></span>
					<a id="dynamicNotesOutLink" title="open link" href="" target="_blank" class="symbol">&#8599;</a>
					<span title="close note" class="link notesClose" onclick="stored_queries.notesClose();">X</span>
				</span>
				<textarea title="notes input area" id="notes" placeholder="write and store notes about this query"
					onkeyup="
						stored_queries.setNoteSize();
						stored_queries.detectLinkInNotes();"
					onselect="stored_queries.detectLinkInNotes();"
					onmouseup="stored_queries.detectLinkInNotes();"></textarea>

				<input title="save" type="button" class="notesButton" onclick="
					stored_queries.saveNotes();" value="save">

				<input title="save" type="button" class="notesButton" onclick="
					stored_queries.saveNotes();
					stored_queries.notesClose();" value="save and close">

				<span title="insert timestamp" class="link"
					onclick="stored_queries.insertStringInNotes('%date%')">insert timestamp</span> |
				<span title="insert line" class="link"
					onclick="stored_queries.insertStringInNotes('%line%')">insert line</span>
			</div>

		</div>
		<!-- /right -->

	</div>
	<!-- /body -->

	<div id="footer">

			<span class="version">
				<span class="appName"></span> | <span class="appVersion"></span> (<span class="appDate"></span>) |
				<!-- Author: <span class="appAuthor"></span> <a href="" class="email appEmail">&#9993;</a> | -->
				<span title="toggle help (F2 also works)"
					onclick="gui.toggleHelp();" class="link">help</span> |
				NBA server: <span id="server"></span>  |
				<span title="Shift pressed" class="indicator shift">S</span>
				<span title="Ctrl pressed" class="indicator ctrl">C</span>
				<span title="AltGr pressed" class="indicator alt">A</span>
			</span>
	</div>
	<!-- /footer -->

</div>
<!-- /page -->

<div id="documentFieldSuggestions"></div>

<div id="queryWindowContextMenu"></div>

<div id="JSONpathDialog">

    <div class="header JSONpathDialogDragHandle">
        <span>JSONpath navigator</span>
        <span class="divider">|</span>
        <span class="link" onclick="
        	json_path.copyResultToClipboard(true);
        	json_path.setMessage('copied JSONPath for JSON results to clipboard');">copy</span>
        <span class="link windowClose" onclick="
        	json_path.clearInput();
        	json_path.clearPathResults();
        	$('#JSONpathToggle').trigger('click');">X</span><br />
    </div>

    <div class="path">
        <input
            type="text"
            id="JSONpath"
            placeholder="JSONPath (double click for '$.resultSet[*].item')"
            onkeyup="json_path.findPath();"
            ondblclick="json_path.pathDblClick();"
            />
    </div>

    <div class="body">
        <pre id="JSONpathDialogContent"
        	ondblclick="json_path.addElementToPath();">
        </pre>
    </div>

 </div>

<div id="loader"><img src="{{ url_for('static', filename='css/images/Spinner-1s-200px.gif') }}"></div>

<div id="dialog" title=""><p class="content"></p></div>

<div id="resultOverlay"></div>

{% include 'templates.html' %}
{% include 'help.html' %}

</body>
</html>